/**
 * Copyright (c) 2006-2008 iWESUN (ShenZhen) Inf.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
 * SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * This file is part of the AvrcX MTOS
 * 
 * Author: Winter Hu  <winter.hu@gmail.com>
 * Create: Nov 26, 2006
 */

#ifndef __UTIL_H__
#define __UTIL_H__


#ifndef __ASSEMBLER__
/* These only work in C programs. */

typedef union union16 {
  unsigned short _word;
  unsigned char  _b[2];
} union16;

typedef union union32 {
  unsigned long  _long;
  union16  _w[2];
  unsigned char _b[4];
} union32;

#define lo8 _b[0]
#define hi8 _b[1]

#define lo16 _w[0]
#define hi16 _w[1]

#define b0 _b[0]
#define b1 _b[1]
#define b2 _b[2]
#define b3 _b[3]

union16 hex2bcd(unsigned char);

union16 hex2asc(unsigned char);

union32 bcd2asc(union16);

union16 asc2bcd(union16);

unsigned char asc2hex(union16);

#if defined __AVR__ && __GNUC__
#include <avr/pgmspace.h>
void print_pgm2uart(const prog_uchar*);
#endif


#endif /* ! __ASSEMBLER__ */


#endif
