/**
 * Copyright (c) 2006-2008 iWESUN (ShenZhen) Inf.
 * All rights reserved. 
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
 * SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * 
 * Author: Winter Hu  <winter.hu@gmail.com>
 * Create: Nov 26, 2006
 */

#include "hardware.h"
#include "../avrcx/avrcx.h"
#include <util/delay.h>

void _drv_init_ukbd(void);

unsigned char _drv_ukbdscan(void);


void _drv_init_ukbd(void){
  DDRB = 0x0E; // PB7~PB4: H1~H4, PB3~PB1: V1~V3
  PORTB= 0xFE;
}


unsigned char _drv_ukbdscan(void){
  unsigned char key;
  unsigned char tmp;

  for(unsigned char v = 3; v > 0; v--){
    tmp = ~(1 << v) & 0xFE;
    PORTB = 0xFE;
    clrBit(PORTB, v);
    _delay_ms(1);
    key = (PINB & 0xFE);
    if (key != tmp) break;
  }
  PORTB = 0xFE;

  if (key == tmp) return 0xFF;

  if (key == 0xEA) return 0x30;
  if (key == 0x7C) return 0x31;
  if (key == 0x7A) return 0x32;
  if (key == 0x76) return 0x33;
  if (key == 0xBC) return 0x34;
  if (key == 0xBA) return 0x35;
  if (key == 0xB6) return 0x36;
  if (key == 0xDC) return 0x37;
  if (key == 0xDA) return 0x38;
  if (key == 0xD6) return 0x39;
  if (key == 0xE6) return 0x23; // #
  if (key == 0xEC) return 0x2A; // *

  return 0xFF;
}

